/* -----------------------------------------------------------------------
 * Title:    sound sensor
 * Author:   Alexander Weber
 * Date:     19.05.2007
 * Hardware: ATmega8
 * Software: WinAVR 20060421
 * 
 */

#include <inttypes.h>
#include <avr/io.h>
#include <util/delay.h>


#define LED_BIT PD4

#define PORT_ON( port_letter, number )			port_letter |= (1<<number)
#define PORT_OFF( port_letter, number )			port_letter &= ~(1<<number)

 void delay_cycles(unsigned long int cycles)
	{
	while(cycles > 0)
		cycles--;
	}

void servo_left(signed long int speed)
	{
	PORT_ON(PORTD, 0);
	delay_cycles(speed);
	PORT_OFF(PORTD, 0);//keep off
	delay_cycles(200);	
}


/*
 * get_adc
 * Return the 10bit value of the selected adc channel.
 */
uint16_t get_adc() {

	uint16_t value;

	// warm up the ADC, discard the first conversion
	ADCSRA |= (1 << ADSC);
	while (ADCSRA & (1 << ADSC)); 
	value = ADCW;
	
	ADCSRA |= (1 << ADSC);				// start single conversion
	while (ADCSRA & (1 << ADSC)); 		// wait until conversion is done

	return ADCW;
}

int main(void) {

	DDRD = 0xFF;
	int n;
	n = 1;
	uint8_t i = 0;
	
	DDRD |= 0x1c;	// PD2-PD3: col 6-7, PD4: debug LED

	// select channel
	ADMUX = 5;

	// ADC setup
	ADCSRA = 
		(1 << ADEN) |						// enable ADC
		(1 << ADPS1) | (1 << ADPS0);		// set prescaler to 8	
			
	// say hello	
	for (i = 0; i < 3; i++) {
		PORTD |= (1 << LED_BIT);
		_delay_ms(100);
		_delay_ms(100);
		_delay_ms(100);
		PORTD &= ~(1 << LED_BIT);
		_delay_ms(100);
		_delay_ms(100);
		_delay_ms(100);
	}
	_delay_ms(200);
	PORTD |= (1 << LED_BIT);


//	while(1) {
//	if (get_adc() > 200) {
//
//	PORTD &= ~(1 << LED_BIT);
 //	_delay_ms(1000);
//
//
//	PORTD |= (1 << LED_BIT);
//	}}

	while(1) {
	if (get_adc() > 300) {
	switch (n) {
	case -1:PORTD |= (1 << LED_BIT); //LED off
			servo_left(24);
			_delay_ms(200); 
			break;
	case 1:	PORTD &= ~(1 << LED_BIT); //LED on
			servo_left(44);
			_delay_ms(200); 
			break;
	}
	n = -n;
		}}

		//_delay_ms(1000);
	
//	switch (n) {
//	case 0: PORTD &= ~(1 << LED_BIT); 
//	case 1: PORTD |= (1 << LED_BIT); 
//	}




	//switch 



//bla:
//	while (1) {
//		_delay_ms(1000);
//		if (get_adc() > 180) {
//			PORTD &= ~(1 << LED_BIT);
//			_delay_ms(1000);
//			PORTD |= (1 << LED_BIT);
		//	_delay_ms(1000);
	//	goto fasdfa;

		//	if (get_adc() > 200) {
		//	PORTD |= (1 << LED_BIT);
		//	}
		//	}
		
	
				
		
//	}


//	fasdfa:
//		_delay_ms(1000);
//		while (1) {
//		if (get_adc() > 200) {
//		PORTD |= (1 << LED_BIT);
//		goto bla;
//		}
//		}


	return 0;

}


